Subject: Re: bug#6299: In read-file-name: (args-out-of-range "c:" 0 3)

From: Lennart Borgman <[email-masked]>
Date: Sun, 30 May 2010 02:10:38 +0200

On Sun, May 30, 2010 at 1:29 AM, Stefan Monnier
<[email-masked]> wrote:
>> BOUNDARIES string="c:" table=read-file-name-internal pred=file-exists-p suffix=""
>> BOUNDARIES boundaries=(boundaries 3)
>
> This appears to be the problem.
>
>  (read-file-name-internal "c:" nil '(boundaries . ""))
>
> seems to return (boundaries 3 . 0).
> Since the code that does that is most likely the one in
> completion--file-name-table which does:
>
>    (let ((start (length (file-name-directory string)))
>          (end (string-match-p "/" (cdr action))))
>      (list* 'boundaries start end)))
>
> my guess is that (file-name-directory "c:") return "c:/".

Yes, that is the case, it returns "c:/".

But I think that is can't return something. However in my opinion it
should return an error because "c:" is not a file path. It is just a
device. It it signaled an error code that tries something like this
would be more easily found and cured.

So I think the problem is that (file-name-directory "c:") is called.
There must be some bad assumption somewhere in the code behind that.

Another suggestion that might help cleaning the code logic in
different places: Add a function directory-root-p

w32: (directory-root-p "c:/") => t
*nix: (directory-root-p "/") => t

w32: (directory-root-p "/") => nil (or signal error, but that would
fit badly with file-directory-p)
*nix: (directory-root-p "c;/") => nil -"-

> I guess we should just use (or (string-match "[^/]*\\'" string) 0)
> instead of (length (file-name-directory string)) but it has N^2
> complexity :-(
>
>
>        Stefan
>